<template>
  <div/>
</template>

<script>
import moment from 'moment'
import { tileLayer } from 'leaflet'
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'
import LeafletGetter from '@/workspace/mixins/LeafletGetter'

export default {
  name: 'wmstimelayer',

  mixins: [
    WorkspaceGetter,
    LeafletGetter,
  ],

  props: {
    layerId: {
      type: String,
      required: true,
    }
  },

  computed: {
    layer: {
      get() {
        return this.$store.getters.workspaceLayerById(this.workspaceId, this.layerId)
      }
    },

    url: {
      get() {
        return this.$store.getters.serviceById(this.layer.service).url
      }
    },

    active: {
      get() {
        return this.layer.status
      }
    },

    referenceTime: {
      get() {
        return this.$store.getters.workspaceReferenceTime(this.workspaceId)
      },
    },

    currentTime: {
      get() {
        return this.$store.getters.workspaceCurrentTime(this.workspaceId)
      }
    },

    pressureLevel: {
      get() {
        return this.$store.getters.workspacePressureLevel(this.workspaceId)
      }
    },
  },

  watch: {
    active(after) {
      if(after) {
        this.__leafletObject.addTo(this.leafletMap)
      } else {
        this.__leafletObject.remove()
      }
    },

    currentTime() {
      this.__leafletObject.setParams({
        ...this.getWmsTemporalDimensions()
      })
    },

    referenceTime() {
      this.__leafletObject.setParams({
        ...this.getWmsTemporalDimensions()
      })
    },

    pressureLevel() {
      this.__leafletObject.setParams({
        dim_pressure_level: this.pressureLevel
      })
    },
  },

  methods: {
    getWmsTemporalDimensions() {
      if(this.url.includes('mf2.ipma.pt')) {
        return {
          reference_time: moment.unix(this.referenceTime).format('YYYY-MM-DDTHH:00:00'),
          //time: moment.unix(this.referenceTime).add(this.step, 'hours').format('YYYY-MM-DDTHH:00:00'),
          time: moment.unix(this.currentTime).format('YYYY-MM-DDTHH:00:00'),
        }
      } else {
        return {
          dim_reference_time: moment.unix(this.referenceTime).format('YYYY-MM-DDTHH:00:00'),
          //time: moment.unix(this.referenceTime).add(this.step, 'hours').format('YYYY-MM-DDTHH:00:00'),
          time: moment.unix(this.currentTime).format('YYYY-MM-DDTHH:00:00'),
        }
      }
    },
  },

  mounted() {
    this.__leafletObject = tileLayer.wms(this.url, {
      ...this.getWmsTemporalDimensions(),
      pane: this.$parent.name,
      layers: this.layer.name,
      format: 'image/png',
      transparent: true,
      tileSize: 512,
      version: '1.3.0',
      dim_pressure_level: this.pressureLevel,
    })

    if(this.active) this.__leafletObject.addTo(this.leafletMap)
  },
}
</script>

